LEETCODE算法:11. Container With Most Water

题目

Given n non-negative integers a1, a2, ..., an , where each represents a point at coordinate (i, ai). n vertical lines are drawn such that the two endpoints of line i is at (i, ai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water.

Note: You may not slant the container and n is at least 2.

img

The above vertical lines are represented by array [1,8,6,2,5,4,8,3,7]. In this case, the max area of water (blue section) the container can contain is 49.

Example:

Input: [1,8,6,2,5,4,8,3,7] Output: 49

题解

1
2
3
4
5
6
7
8
9
10
11
12
13
14
//双指针
class Solution {
public:
int maxArea(vector<int>& height) {
int ans=0,i=0,j=height.size()-1;
while(i<j)
{
ans=max(ans,(j-i)*min(height[i],height[j]));
if(height[i]>height[j]) j--;
else i++;
}
return ans;
}
};
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
//暴力算法,两个测试点超时
class Solution {
public:
int maxArea(vector<int>& height) {
int ans=0;
for(int i=0;i<height.size();i++)
{
for(int j=i+1;j<height.size();j++)
{
ans=max(ans,(j-i)*min(height[j],height[i]));
}
}
return ans;
}
};

说明

双指针为什么可行?

两个指针初始分别指向开头和末尾,本题我们要求最大容积(面积),如果左侧高度小于右侧高度,那么右侧边界如何向左移动都不会比现在的容积更大,因为高度不变,长度变小,所以可以舍弃。